#!/usr/bin/env node

/**
 * Tmplify prototype.
 */

"use strict";

process.chdir(__dirname + '/..');

var path = require('path'),
    fs = require('fs'),
    apeTasking = require('ape-tasking'),
    tmplconv = require('tmplconv');

var scaffold = require('../lib');

var demo = path.dirname(require.resolve('../asset/prototype/package.json'));

apeTasking.runTasks('tmplify', [
    function (callback) {
        tmplconv.tmplify(demo, 'asset/tmpl', {
            clean: true,
            mode: '444',
            pattern: [
                '**/*.*',
                '.*'
            ],
            ignore: [
                '.DS_Store',
                '.svg'
            ],
            data: {
                'github_repository': "my-wonderful-repo/my-awesome-pkg",
                'package_name': 'my-awesome-pkg',
                'package_description': 'This is my awesome package.',
                'author_name': 'Taka Okunishi',
                'author_email': 'okunishitaka.com@gmail.com',
                'author_url': 'http://okunishitaka.com'
            },
            prefix: scaffold.prefix,
            suffix: scaffold.suffix
        }, callback);
    },
    function (callback) {
        tmplconv.tmplify(__dirname + '/..', 'asset/tmpl', {
            pattern: [
                '.gitignore'
            ],
            prefix: scaffold.prefix,
            suffix: scaffold.suffix
        }, callback);
    },
    function (callback) {
        var filename = require.resolve('../asset/tmpl/package.json.tmpl');
        var str = fs.readFileSync(filename).toString();
        var pkg = JSON.parse(str);
        pkg.version = '1.0.0';
        delete pkg['readme'];
        delete pkg['readmeFilename'];
        delete pkg['gitHead'];
        delete pkg['_id'];
        delete pkg['_shasum'];
        delete pkg['_from'];
        fs.chmodSync(filename, '644');
        fs.writeFileSync(filename, JSON.stringify(pkg, null, 2));
        fs.chmodSync(filename, '444');
        callback(null);
    }
], true);
